(*   vvvv - name changed by sv *)
{$I TICGUARD.INC}
unit tg_misc;
interface
  uses tg_glob;

  function DelDblSpaces(s:string):string;
  function upstr (s:string):string;
  function ROOff(pathname:string):boolean;
  Function NextWord(s:string;var j:byte):string;
  procedure CorrectFileName(var fname:string);
  procedure CorrectPath(var path:string);
  Function StripPath(s:string):string;
  function GetTicRec(fname:string;Var OutTic: Ttic):byte;
  Function MoveFile(Pathname1,Pathname2:string):byte; {Result}

implementation
  uses dos;

  function DelDblSpaces(s:string):string;
  var
    i, done : integer;
  begin
    done:=0;
    while done=0 do
    begin
      i:=pos('  ',s);
      if i>0 then
        delete(s,i,1)
      else
        done:=1;
    end;
    If s[1]=' ' then
      delete(s,1,1);
    If s[length(s)]=' ' then
      delete(s,Length(s),1);
    delDblspaces:=s;
  end;{DelDblSpaces}

  function upstr (s:string):string;
  var
    i : integer;
  begin
    for i:=1 to length(s) do
      s[i]:=UpCase(s[i]);
    upstr:=s;
  end;{UpStr}

  function ROOff(pathname:string):boolean;
  var
    f    : file;
    attr : longint;
  begin
    ROOFF:=false;
    assign(f,pathname);
    getfattr(f,attr);
    if doserror=0 then
      if attr and readonly <> 0 then
      begin
        setfattr(f,attr - readonly);
        ROOFF:=True;
      end;
  end;

  Function NextWord;
  var
    i : byte;
  begin
    i:=j+1;
    j:=i;
    while (s[j]<>' ')and(j<=length(s)) do
    begin
      inc(j);
    end;
    NextWord:=copy(s,i,j-i)
  end;{Next word}

  procedure CorrectFileName(var fname:string);
  var
    i      : Integer;
    curdir : string;
  begin
    (*/ 塞    - /*)
    for i:=1 to length(fname) do
      if fname[i]='/' then
        fname[i]:='\';
    (*/ 塞  - /*)
    i:=pos('\\',fname);
    while i>0 do
    begin
      delete(fname,i,1);
      i:=pos('\\',fname);
    end;
    (*/ ᫨  稭  '\',  ⠢塞 ।  ⥪騩  /*)
    if fname[1]='\' then
    begin
      GetDir(0,curdir);
      fname:=copy(curdir,1,2)+fname;
    end;
  end;{CorrectFileName}

  procedure CorrectPath(var path:string);
  var
    i      : Integer;
    curdir : string;
  begin
    CorrectFileName(path);
    (*/ ᫨  稢  '\',  ⠢塞    /*)
    if path[length(path)]='\' then
      path[0]:=pred(path[0]);
  end;{CorrectPath}

  Function StripPath(s:string):string;
  var
    b : byte;
  begin
    b:=length(s);
    while (s[b]<>'\')and(b>0) do
      dec(b);
    StripPath:=copy(s,b+1,length(s)-b);
  end;

  function GetTicRec(fname:string;Var OutTic: Ttic):byte;
  const
    hex = '0123456789ABCDEF';
  var
    t       : text;
    res     : byte;
    s       : string;
    b       : byte;
    WasCRC,
    WasFile : boolean;
  begin
    GetTicRec:=er_AllOk;
    With OutTic do
    begin
      FName:='';
      Tic:='';
      NextTic:=nil;
    end;
    WasCRC:=false;
    WasFile:=false;

    s:=StripPath(fname);
    b:=pos('.',s);
    if b>0 then
      s:=copy(s,1,b-1);
    OutTic.Tic:=s;

    assign(t,fname);
    reset(t);
    res:=ioresult;
    if res<>er_allok then
    begin
      GetTicRec:=Res;
      Exit;
    end;
    While ((not wasfile) or (not wascrc))and(not eof(t)) do
    begin
      readln(t,s);
      s:=UpStr(DelDblSpaces(s));

      b:=0;
      If NextWord(s,b) = 'FILE' then
      begin
        OutTic.FName:=NextWord(s,b);
        WasFile:=true;
        Continue;
      end;

      b:=0;
      If UpStr(NextWord(s,b)) = 'CRC' then
      begin
        s:=UpStr(NextWord(s,b));
        if (s[0]<>#08)or
          (not((s[1] in ['0'..'9'])or(s[1] in ['A'..'F']))) or
          (not((s[2] in ['0'..'9'])or(s[2] in ['A'..'F']))) or
          (not((s[3] in ['0'..'9'])or(s[3] in ['A'..'F']))) or
          (not((s[4] in ['0'..'9'])or(s[4] in ['A'..'F']))) or
          (not((s[5] in ['0'..'9'])or(s[5] in ['A'..'F']))) or
          (not((s[6] in ['0'..'9'])or(s[6] in ['A'..'F']))) or
          (not((s[7] in ['0'..'9'])or(s[7] in ['A'..'F']))) or
          (not((s[8] in ['0'..'9'])or(s[8] in ['A'..'F']))) then
        begin
          GetTicRec:=er_TicError;
          Exit;
        end;
        OutTic.CRC32:=0;
        For b:=1 to 8 do
          OutTic.CRC32:=(OutTic.CRC32 SHL 4) OR (pos(s[b], hex)-1);
        WasCRC:=true;
      end;
    end;
    Close(t);
    Res:=IOResult;
    if (OutTic.FName='')or(not WasCRC) then
      GetTicRec:=er_TicError;
  end;{GetTicRec}

  Function MoveFile(Pathname1,Pathname2:string):byte; {Result}
  var
    find   : searchrec;
   res: word;
    f1,f2  : file;

    function copydelete:byte;
    var
      FTime      : longint;
      attr,i     : longint;
      ChangeAttr : boolean;{  ਡ Read-only}
      BufSize,
      BufFill    : word;
      Buffer     : pointer; {  ஢}
      File_Size  : longint;
    begin
      copydelete:=er_allok;
      assign(f1,pathname1);
      getfattr(f1,attr);
      ChangeAttr:=ROOFF(pathname1);
      filemode:=0;
      reset(f1,1);
      Filemode:=2;
      res:=ioresult;
      If res<>0 then
      begin
        CopyDelete:=res;
        Exit;
      end;

      GetFTime(F1,FTime);
      assign(f2,pathname2);
      ROOFF(pathname2);
      rewrite(f2,1);
      res:=ioresult;
      if res<>0 then
      begin
        CopyDelete:=res;
        close(f1);
        Exit;
      end;

      if MaxAvail=0 then
      begin
        CopyDelete:=er_MemoryError;
        close(f1);
        close(f2);
        Erase(f2);
        res:=ioresult;
        Exit;
      end;

      File_size:=Filesize(f1);
      {// 뤥塞    ஢}
      If MaxAvail>65520 then
        BufSize:=65520
      else
        BufSize:=MaxAvail;
      if file_size<bufsize then
        bufsize:=file_size;
      GetMem(Buffer,BufSize);
      repeat
        If bufsize<=file_size then
          buffill:=bufsize
        else
          buffill:=file_size;
        blockread(f1,buffer^,Buffill);
        res:=ioresult;
        if res<>0 then
        begin
          copydelete:=res;
          freemem(buffer,bufsize);
          close(f1);
          close(f2);
          erase(f2);
          res:=ioresult;
          exit;
        end;
        Dec(File_Size,buffill);
        BlockWrite(f2, buffer^, buffill {NumRead}{, NumWritten});
        res:=ioresult;
        if res<>0 then
        begin
          copydelete:=res;
          freemem(buffer,bufsize);
          close(f1);
          close(f2);
          erase(f2);
          res:=ioresult;
          exit;
        end;
      until (File_Size=0);
      {// ᢮    }
      FreeMem(Buffer,BufSize);
      setftime(f2,ftime);
      Close(f1);
      Close(f2);
      setfattr(f2,attr);
      Erase(f1);
      res:=ioresult;
      If res<>er_allok then
      begin
        copydelete:=res;
        Exit;
      end;
    end;

    function moverename:byte;
    begin
      moverename:=er_allok;
      findfirst(pathname2, anyfile-volumeid-directory, find);
      if doserror=0 then
      begin
        rooff(pathname2);
        assign(f2,pathname2);
        erase(f2);
        res:=ioresult;
        if res<>0 then
        begin
          moverename:=res;
          exit;
        end;
      end;
      assign(f1,pathname1);
      rename(f1,pathname2);
      res:=ioresult;
      if res<>er_allok then
      begin
        moverename:=res;
        exit;
      end;
    end; {use rename}

begin
  if (upcase(pathname1[1])<>upcase(pathname2[1]))and(pathname1[2]=':')and(pathname2[2]=':')then
    res:=copydelete
  else
  begin
    res:=moverename;
    if res=er_CantRenAcrDrv then
      res:=copydelete;
  end;
  MoveFile:=res;
end;{MoveFile}


begin
end.
