Library TICGUARD;

{$LINKER
DESCRIPTION "TIC Guard (build '+ProgramVersion+')  (c) 1998  Paul Yanchenko // WHG"}

(*   vvvv - name changed by sv *)
{$I TICGUARD.INC}

(*************************************************************)
(* Some modification for compiling under OS/2 added by sv    *)
(*************************************************************)

{$IFNDEF VIRTUALPASCAL}
USES
  Dos,
  TG_Misc,
  TG_Error,
  Tg_Glob,
  GetCrc32,
  dllutil,
  master;
{$ELSE}
USES
  Dos,
  TG_Misc,
  TG_Error,
  Tg_Glob,
  master,
  dllutil,
  GetCrc32;
{$ENDIF}

CONST
  ProgramVersion = '0924'; {  ணࠬ  UNIX-ଠ }

VAR

  Tic1stPtr : pointer; {  㪠⥫    ᪮ ᨢ }
  Tic       : ^Ttic;   { ந  ⮣ ᨢ }
  TmpTic    : Ttic;    {  ६  }
  TicNum    : word;    {  ⥪饣 ⨪ }
  DupesFound: word;    { -  㯮 }
  IncorrectTics:word;  { - ⨪  ࠢ CRC }

  Find      : SearchRec;

  Res       : byte;
  ResW      : word;

  ScanDir   : String; { ४  ᪠஢ tic' }
  BadDir    : String; { ४, 㤠   娥 tic' }

  Function CompTime:string; {६ 樨 ணࠬ}
    {$I CompTime.Pas}

  PROCEDURE SortTic;
  Var
    done      : boolean;
    CurTic,
    PrevTic   : ^Ttic;
  Begin
    done:=false;
    while not done do
    begin
      PrevTic:=nil;
      CurTic:=Tic1stPtr;
      done:=true;
      While CurTic^.nexttic<>nil do
      begin
        PrevTic:=CurTic;
        CurTic:=CurTic^.NextTic;
        If PrevTic^.FName > CurTic^.FName then
        begin
          TmpTic:=PrevTic^;
          PrevTic^.fname:=CurTic^.fname;
          PrevTic^.tic:=CurTic^.tic;
          PrevTic^.crc32:=CurTic^.crc32;
          CurTic^.fname:=tmptic.fname;
          CurTic^.tic:=tmptic.tic;
          CurTic^.crc32:=tmptic.crc32;
          done:=false;
        end;
      end;
    end;
  End;{SortTic}

  PROCEDURE RemoveDupes;
  var
    PrevTic,
    CurTic    : ^Ttic;
    FileName  : string[12];
    FileCrc32 : longint;
    Res       : byte;
    f         : file;
    prevticwasdeleted:boolean;
  begin
    PrevTic:=nil;
    CurTic:=Tic1stPtr;
    FileName:='';
    PrevTicWasDeleted:=false;
    While CurTic^.nexttic<>nil do
    begin
      PrevTic:=CurTic;
      CurTic:=CurTic^.NextTic;
      If PrevTic^.FName = CurTic^.FName then
      begin
{Beg: added in 0.9.2}
        inc(dupesfound);
{End: added in 0.9.2}
        if filename<>curtic^.fname then
        begin
{Beg: added in 0.9.2}
          {inc(dupesfound);}
          vprint('Calculating CRC of '+CurTic^.FName+' - ');
{End: added in 0.9.2}
          Res:=GetFileCrc32(ScanDir+'\'+CurTic^.FName,FileCrc32);
{Beg: changed in 0.9.2}
          vprintln(errormsg(res));
          if res<>er_AllOk then
            Continue;
          FileName:=CurTic^.FName;
{End: changed in 0.9.2}
        end;

        if (PrevTic^.crc32 <> FileCrc32)and(not PrevTicWasDeleted) then
        begin
          if paramcount = 2 then
          begin
            vprint('Moving '+PrevTic^.tic+'.TIC to '+BadDir+' - ');
            Res:=movefile(ScanDir+'\'+PrevTic^.tic+'.TIC', BadDir+'\'+PrevTic^.tic+'.TIC');
            writeln(ErrorMsg(Res));
          end
          else
          begin
            vprint('Deleting '+PrevTic^.tic+'.TIC - ');
            Assign(f,ScanDir+'\'+PrevTic^.tic+'.TIC');
            Erase(f);
            res:=ioresult;
            writeln(errormsg(res));
          end;
{Beg:changed in 0.9.2}
          {inc(DupesFound);}
          inc(IncorrectTics);
{End:changed in 0.9.2}
        end;

        if CurTic^.crc32 <> FileCrc32 then
        begin
          if paramcount = 2 then
          begin
            vprint('Moving '+CurTic^.tic+'.TIC to '+BadDir+' - ');
            Res:=movefile(ScanDir+'\'+CurTic^.tic+'.TIC', BadDir+'\'+CurTic^.tic+'.TIC');
            writeln(ErrorMsg(Res));
          end
          else
          begin
            vprint('Deleting '+CurTic^.tic+'.TIC - ');
            Assign(f,ScanDir+'\'+CurTic^.tic+'.TIC');
            Erase(f);
            res:=ioresult;
            writeln(errormsg(res));
          end;
          PrevTicWasDeleted:=true;
{Beg:changed in 0.9.2}
          {inc(DupesFound);}
          inc(IncorrectTics);
{End:changed in 0.9.2}
        end;
      end
      else
        PrevTicWasDeleted:=False;
    end;
  end;{RemoveDupes}

  PROCEDURE FreeTics;
  Var
    CurTic,
    PrevTic : ^Ttic;
  Begin
    PrevTic:=nil;
    CurTic:=Tic1stPtr;
    While CurTic^.nexttic<>nil do
    begin
      PrevTic:=CurTic;
      CurTic:=CurTic^.NextTic;
      FreeMem(PrevTic,sizeof(ttic));
    end;
    FreeMem(CurTic,sizeof(ttic));
  End;{FreeTics}

function id:string;export;
begin
id:='TIC Guard (build '+ProgramVersion+')  (c) 1998  Paul Yanchenko // WHG';
end;

procedure beforetoss (scandir,baddir:string);export;
var y:word;
begin
  Tic1stPtr:=nil;
  TicNum:=0;
  DupesFound:=0;
  IncorrectTics:=0;
  CorrectPath(ScanDir);
  FindFirst(ScanDir,Directory,find);
  Res:=DosError;
  if Res<>er_AllOk then
  begin
    vprintln(ScanDir+' - dir not found!');
    Exit;
  end;

  if BadDir<>'' then
  begin
    CorrectPath(BadDir);
    FindFirst(BadDir,Directory,find);
    Res:=DosError;
    if Res<>er_AllOk then
    begin
      vprintln(BadDir+' - dir not found!');
      Exit;
    end;
  end
  else
    BadDir:='';

  If ScanDir = BadDir then
  begin
    vprintln('Error - <InboundTicsDir> can not be the same as <BadTicsDir>');
    Exit;
  end;

  y:=vwherey;

  FindFirst(ScanDir+'\*.TIC',AnyFile-Directory-VolumeId,Find);
  While DosError = 0 do
  Begin
    vgotoxy(1,y);
    vprintln('Reading '+Find.name+' - ');vclreol;
    Res:=GetTicRec(ScanDir+'\'+find.name,TmpTic);
    vprintln(ErrorMsg(Res));
    if Res = er_AllOk then
    begin
      if maxavail < SizeOf(Ttic) then
      begin
        vprintln('Error #'+int2str(Res)+': '+ErrorMsg(Res));
        Exit;
      end;
      if Tic1stPtr=nil then
      begin
        getmem(Tic1stPtr,SizeOf(Ttic));
        tic:=Tic1stPtr;
      end
      else
      begin
        getmem(tic^.nexttic,SizeOf(Ttic));
        tic:=tic^.nexttic;
      end;
      inc(ticnum);
      tic^:=TmpTic;
    end;
    FindNext(find);
  End;

  If ticnum<=1 then
  begin
   vprintln('');
   vprintln('Nothing to do');
   Exit;
  end;

  If ticnum>1 then
    SortTic;

  vprintln('');
  RemoveDupes;
{Beg:changed in 0.9.2}
  vprintln('');
{End:changed in 0.9.2}
  if DupesFound=0 then
    vprintln('There are no duplicated TICs')
{Beg:changed in 0.9.2}
  else
    vprintln('Duplicated tics - '+int2str(dupesfound)+' with bad CRC - '+int2str(incorrecttics));
{End:changed in 0.9.2}
  FreeTics;
end;

exports
beforetoss,
vinit,
id;

begin
END.
